# Upbit Open API
#
# ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
#
# OpenAPI spec version: 1.0.0
# Contact: ujhin942@gmail.com
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' OrderChance Class
#'
#' @field bid_fee 
#' @field ask_fee 
#' @field market 
#' @field bid_account 
#' @field ask_account 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
OrderChance <- R6::R6Class(
  'OrderChance',
  public = list(
    `bid_fee` = NULL,
    `ask_fee` = NULL,
    `market` = NULL,
    `bid_account` = NULL,
    `ask_account` = NULL,
    initialize = function(`bid_fee`, `ask_fee`, `market`, `bid_account`, `ask_account`){
      if (!missing(`bid_fee`)) {
        stopifnot(is.character(`bid_fee`), length(`bid_fee`) == 1)
        self$`bid_fee` <- `bid_fee`
      }
      if (!missing(`ask_fee`)) {
        stopifnot(is.character(`ask_fee`), length(`ask_fee`) == 1)
        self$`ask_fee` <- `ask_fee`
      }
      if (!missing(`market`)) {
        stopifnot(R6::is.R6(`market`))
        self$`market` <- `market`
      }
      if (!missing(`bid_account`)) {
        stopifnot(R6::is.R6(`bid_account`))
        self$`bid_account` <- `bid_account`
      }
      if (!missing(`ask_account`)) {
        stopifnot(R6::is.R6(`ask_account`))
        self$`ask_account` <- `ask_account`
      }
    },
    toJSON = function() {
      OrderChanceObject <- list()
      if (!is.null(self$`bid_fee`)) {
        OrderChanceObject[['bid_fee']] <- self$`bid_fee`
      }
      if (!is.null(self$`ask_fee`)) {
        OrderChanceObject[['ask_fee']] <- self$`ask_fee`
      }
      if (!is.null(self$`market`)) {
        OrderChanceObject[['market']] <- self$`market`$toJSON()
      }
      if (!is.null(self$`bid_account`)) {
        OrderChanceObject[['bid_account']] <- self$`bid_account`$toJSON()
      }
      if (!is.null(self$`ask_account`)) {
        OrderChanceObject[['ask_account']] <- self$`ask_account`$toJSON()
      }

      OrderChanceObject
    },
    fromJSON = function(OrderChanceJson) {
      OrderChanceObject <- jsonlite::fromJSON(OrderChanceJson)
      if (!is.null(OrderChanceObject$`bid_fee`)) {
        self$`bid_fee` <- OrderChanceObject$`bid_fee`
      }
      if (!is.null(OrderChanceObject$`ask_fee`)) {
        self$`ask_fee` <- OrderChanceObject$`ask_fee`
      }
      if (!is.null(OrderChanceObject$`market`)) {
        marketObject <- Market$new()
        marketObject$fromJSON(jsonlite::toJSON(OrderChanceObject$market, auto_unbox = TRUE))
        self$`market` <- marketObject
      }
      if (!is.null(OrderChanceObject$`bid_account`)) {
        bid_accountObject <- BidAccount$new()
        bid_accountObject$fromJSON(jsonlite::toJSON(OrderChanceObject$bid_account, auto_unbox = TRUE))
        self$`bid_account` <- bid_accountObject
      }
      if (!is.null(OrderChanceObject$`ask_account`)) {
        ask_accountObject <- AskAccount$new()
        ask_accountObject$fromJSON(jsonlite::toJSON(OrderChanceObject$ask_account, auto_unbox = TRUE))
        self$`ask_account` <- ask_accountObject
      }
    },
    toJSONString = function() {
       sprintf(
        '{
           "bid_fee": %s,
           "ask_fee": %s,
           "market": %s,
           "bid_account": %s,
           "ask_account": %s
        }',
        self$`bid_fee`,
        self$`ask_fee`,
        self$`market`$toJSON(),
        self$`bid_account`$toJSON(),
        self$`ask_account`$toJSON()
      )
    },
    fromJSONString = function(OrderChanceJson) {
      OrderChanceObject <- jsonlite::fromJSON(OrderChanceJson)
      self$`bid_fee` <- OrderChanceObject$`bid_fee`
      self$`ask_fee` <- OrderChanceObject$`ask_fee`
      MarketObject <- Market$new()
      self$`market` <- MarketObject$fromJSON(jsonlite::toJSON(OrderChanceObject$market, auto_unbox = TRUE))
      BidAccountObject <- BidAccount$new()
      self$`bid_account` <- BidAccountObject$fromJSON(jsonlite::toJSON(OrderChanceObject$bid_account, auto_unbox = TRUE))
      AskAccountObject <- AskAccount$new()
      self$`ask_account` <- AskAccountObject$fromJSON(jsonlite::toJSON(OrderChanceObject$ask_account, auto_unbox = TRUE))
    }
  )
)
